#!/usr/bin/env python2.7

import matplotlib.pyplot as plt
import numpy as np

cnver_gain_old      = [0, 3, 3, 2, 3]
cnver_gain_young    = [0, 0, 0, 4, 5]

cnver_loss_old      = [8, 3, 5, 4, 1]
cnver_loss_young    = [3, 3, 3, 4, 7]

bk_loss_old         = [3, 3, 5, 7, 5]
bk_loss_young       = [3, 7, 1, 3, 5]

cnvnator_gain_old   = [1, 4, 3, 5]
cnvnator_gain_young = [4, 5, 2, 5, 5]

cnvnator_loss_old   = [4, 10, 6, 10]
cnvnator_loss_young = [6, 5, 6, 9, 10]

erds_gain_old       = [0, 5, 4, 1, 0]
erds_gain_young     = [7, 7, 4, 6, 3]

erds_loss_old       = [10, 9, 6, 6, 5]
erds_loss_young     = [1, 6, 5, 2, 7]

fig = plt.figure(figsize = (5.5, 4.25))
fig.subplots_adjust(left = 0.06, bottom = 0.07, right = 0.95, top = 0.94,
    wspace = 0.18, hspace = 0.5)

axes = [
    plt.subplot(2, 2, 1),
    plt.subplot(2, 2, 2),
    plt.subplot(2, 2, 3),
    plt.subplot(2, 2, 4),
]

for i in xrange(len(axes)):
    if i != 0 and i != 2:
        axes[i].get_yaxis().set_ticks([])

t = axes[0].boxplot([cnver_loss_young, cnver_loss_old], widths = .4)
axes[0].set_title('CNVer')
axes[0].set_axisbelow(True)
axes[0].xaxis.set_ticks_position("bottom")
axes[0].yaxis.set_ticks_position("left")
axes[0].spines["top"].set_visible(False)
axes[0].spines["right"].set_visible(False)
plt.setp(t["boxes"], color="black", lw = 2)
plt.setp(t["whiskers"], color="black", lw = 2)
plt.setp(t["fliers"], color="black", mew = 2)

t = axes[1].boxplot([cnvnator_loss_young, cnvnator_loss_old], widths = .4)
axes[1].set_title('CNVnator')
axes[1].set_axisbelow(True)
axes[1].xaxis.set_ticks_position("bottom")
axes[1].yaxis.set_ticks_position("none")
axes[1].spines["top"].set_visible(False)
axes[1].spines["right"].set_visible(False)
axes[1].spines["left"].set_visible(False)
plt.setp(t["boxes"], color="black", lw = 2)
plt.setp(t["whiskers"], color="black", lw = 2)
plt.setp(t["fliers"], color="black")

t = axes[2].boxplot([erds_loss_young, erds_loss_old], widths = .4)
axes[2].set_title('ERDS')
axes[2].set_axisbelow(True)
axes[2].xaxis.set_ticks_position("bottom")
axes[2].yaxis.set_ticks_position("left")
axes[2].spines["top"].set_visible(False)
axes[2].spines["right"].set_visible(False)
plt.setp(t["boxes"], color="black", lw = 2)
plt.setp(t["whiskers"], color="black", lw = 2)
plt.setp(t["fliers"], color="black")

t = axes[3].boxplot([bk_loss_young, bk_loss_old], widths = .4)
axes[3].set_title('BreakDancer')
axes[3].set_axisbelow(True)
axes[3].xaxis.set_ticks_position("bottom")
axes[3].yaxis.set_ticks_position("none")
axes[3].spines["top"].set_visible(False)
axes[3].spines["right"].set_visible(False)
axes[3].spines["left"].set_visible(False)
plt.setp(t["boxes"], color="black", lw = 2)
plt.setp(t["whiskers"], color="black", lw = 2)
plt.setp(t["fliers"], color="black")

for ax in axes:
    plt.setp(ax, xticklabels = ['Young', 'Old'])
    ax.set_ylim(-1, 11)

# plt.savefig('box-plots.png', dpi = 300)
plt.savefig('box-plots.png', dpi = 1000, transparent = True)
