import cnv_struct
import parsers
import numpy as np
import merge_cnvs
import mendelian

families = ['family_1490', 'family_1480', 'family_1389', 'family_1207', 'family_1121', 'family_1652', 'family_1286', 'family_1443', 'family_1323', 'family_1301']

algos = ['cnver', 'break-dancer', 'cnvnator', 'erds']

counts_per_sample = {
    'cnver': [],
    'break-dancer': [],
    'cnvnator': [],
    'erds': [],
}

chromosome_lengths = {
    'chr1': 249250621,
    'chr2': 243199373,
    'chr3': 198022430,
    'chr4': 191154276,
    'chr5': 180915260,
    'chr6': 171115067,
    'chr7': 159138663,
    'chr8': 146364022,
    'chr9': 141213431,
    'chr10': 135534747,
    'chr11': 135006516,
    'chr12': 133851895,
    'chr13': 115169878,
    'chr14': 107349540,
    'chr15': 102531392,
    'chr16': 90354753,
    'chr17': 81195210,
    'chr18': 78077248,
    'chr19': 59128983,
    'chr20': 63025520,
    'chr21': 48129895,
    'chr22': 51304566,
    'chrX': 155270560,
    'chrY': 59373566,
}

#### NUMBER OF CALLS ####
# for a in algos:
#     for f in families:
#         path = '/Users/legaultmarc/Dropbox/cnv/analysis/data/' + a + '/' + f
#         if a == 'break-dancer':
#             p = parsers.get_parser_for_algorithm('breakdancer') 
#         else:
#             p = parsers.get_parser_for_algorithm(a) 
#         p = p(path)
#         cnvs = p.get_cnvs()
#         # cnvs = merge_cnvs.merge(cnvs)
# 
#         for sample in cnvs:
#             count = 0
#             for chromo in cnvs[sample]:
#                 count += len(cnvs[sample][chromo])
#             counts_per_sample[a].append(count)
# 
# for a in counts_per_sample:
#     arr = np.array(counts_per_sample[a])
#     print a, np.mean(arr), np.std(arr)
####

#### Size ####
# for a in algos:
#     for f in families:
#         path = '/Users/legaultmarc/Dropbox/cnv/analysis/data/' + a + '/' + f
#         if a == 'break-dancer':
#             p = parsers.get_parser_for_algorithm('breakdancer') 
#         else:
#             p = parsers.get_parser_for_algorithm(a) 
#         p = p(path)
#         cnvs = p.get_cnvs()
#         # cnvs = merge_cnvs.merge(cnvs)
# 
#         for sample in cnvs:
#             sz = []
#             for chromo in cnvs[sample]:
#                 for cnv in cnvs[sample][chromo]:
#                     sz.append(cnv.size / 1000.0)
#             if len(sz) > 0:
#                 counts_per_sample[a].append(np.mean(np.array(sz)))
# 
# for a in counts_per_sample:
#     arr = np.array(counts_per_sample[a])
#     print a, np.mean(arr), np.std(arr)
####

#### Distance between CNVs ####
# for a in algos:
#     for f in families:
#         path = '/Users/legaultmarc/Dropbox/cnv/analysis/data/' + a + '/' + f
#         if a == 'break-dancer':
#             p = parsers.get_parser_for_algorithm('breakdancer') 
#         else:
#             p = parsers.get_parser_for_algorithm(a) 
#         p = p(path)
#         cnvs = p.get_cnvs()
#         cnvs = merge_cnvs.merge(cnvs)
# 
#         for sample in cnvs:
#             distances = []
#             for chromo in cnvs[sample]:
#                 sorted_cnvs = sorted(cnvs[sample][chromo], key = lambda x: x.start)
#                 i = 0
#                 while i < len(sorted_cnvs) - 1:
#                     cnv = sorted_cnvs[i]
#                     next_cnv = sorted_cnvs[i + 1]
#                     if cnv.type == next_cnv.type:
#                         dist = (next_cnv.start - cnv.end - 1) / 1000.0
#                         distances.append(dist)
#                         if dist < 0:
#                             raise Exception('Negative distance')
#                     i += 1
# 
#             distances = np.array(distances)
#             if len(distances) > 0:
#                 counts_per_sample[a].append(np.mean(distances))
# 
# for a in counts_per_sample:
#     arr = np.array(counts_per_sample[a])
#     print a, np.mean(arr), np.std(arr)
####

#### Genome coverage ####
for a in algos:
    for f in families:
        path = '/Users/legaultmarc/Dropbox/cnv/analysis/data/' + a + '/' + f
        if a == 'break-dancer':
            p = parsers.get_parser_for_algorithm('breakdancer') 
        else:
            p = parsers.get_parser_for_algorithm(a) 
        p = p(path)
        cnvs = p.get_cnvs()
        # cnvs = merge_cnvs.merge(cnvs)

        for sample in cnvs:
            coverage_per_chromosome = {}
            for chromo in cnvs[sample]:
                cov = 0
                for cnv in cnvs[sample][chromo]:
                    cov += cnv.size
                coverage_per_chromosome[chromo] = (1.0 * cov / 
                    chromosome_lengths['chr' + str(chromo)])
            # Compute mean chromosome coverage for sample.
            mean_cov_for_sample = np.array(coverage_per_chromosome.values())
            if len(mean_cov_for_sample) > 0:
                mean_cov_for_sample = np.mean(mean_cov_for_sample)
                counts_per_sample[a].append(mean_cov_for_sample)

for a in counts_per_sample:
    arr = np.array(counts_per_sample[a])
    print a, np.mean(arr), np.std(arr)
####

#### Inherited rate ####
# for a in algos:
#     for f in families:
#         path = '/Users/legaultmarc/Dropbox/cnv/analysis/data/' + a + '/' + f
#         if a == 'break-dancer':
#             p = parsers.get_parser_for_algorithm('breakdancer') 
#         else:
#             p = parsers.get_parser_for_algorithm(a) 
#         p = p(path)
#         cnvs = p.get_cnvs()
#         cnvs = merge_cnvs.merge(cnvs)
# 
#         inherited, counts = mendelian.get_inherited(cnvs, 0.7, 0.7)
#         rate = 1.0 * len(inherited) / counts['total']
#         counts_per_sample[a].append(rate)
# 
# for a in counts_per_sample:
#     arr = np.array(counts_per_sample[a])
#     print a, np.mean(arr), np.std(arr)
