#!/usr/bin/env python2.7

import argparse

import validation
import parsers

def main(args):
    if (args.base_dir1 and 
        args.base_dir2 and
        args.format1 and
        args.format2):

        p1 = parsers.get_parser_for_algorithm(args.format1)
        p1 = p1(args.base_dir1)
        cnvs1 = p1.get_cnvs()

        p2 = parsers.get_parser_for_algorithm(args.format2)
        p2 = p2(args.base_dir2)
        cnvs2 = p2.get_cnvs()

    elif (args.pickle1 and
          args.pickle2 and
          args.family):
         p1 = parsers.cnvpickle.Parser
         p1 = p1(args.pickle1, args.family)
         cnvs1 = p1.get_cnvs()

         p2 = parsers.cnvpickle.Parser
         p2 = p2(args.pickle2, args.family)
         cnvs2 = p2.get_cnvs()

    else:
        sys.exit("Either provide two --base_dir and the corresponding --format"
                 "s, or two --pickle with the corresponding --family.")

# TODO
    

if __name__ == "__main__":
    parser = argparse.ArgumentParser(description = ("Computes the concordant "
                                                    "CNVs in the same sample "
                                                    "for two different algor "
                                                    "ithms."))

    parser = validation.add_pickle_args(parser)

    parser.add_argument(
                            "--format1",
                            type=str,
                            choices=parsers.__all__,
                            help="The file format for the 1st algorithm."
                       )

    parser.add_argument(
                            "--format2",
                            type=str,
                            choices=parsers.__all__,
                            help="The file format for the 2nd algorithm."
                       )

    parser.add_argument(
                            "--base_dir1",
                            type=str,
                            help=("The base directory for the calls. A directory "
                                  "with four subfodlers starting with father, "
                                  "mother, twin1 and twin2 are expected.")
                       )

    parser.add_argument(
                            "--base_dir2",
                            type=str,
                            help=("The base directory for the calls. A directory "
                                  "with four subfodlers starting with father, "
                                  "mother, twin1 and twin2 are expected.")
                       )

    parser.add_argument(
                            "--pickle1",
                            type=str,
                            help=("Pickle file to compare.")
                       )

    parser.add_argument(
                            "--pickle2",
                            type=str,
                            help=("Second pickle file to compare.")
                       )

    parser.add_argument(
                            "--family",
                            type=str,
                            help="Family ID for pickled data." 
                       )

    main(parser.parse_args())
